#/***********************************************************
#    mapsort.rb
#***********************************************************/
MAX = 1000
MIN = 0

def mapsort(n,  a,  b,  nxt)
    index = []

    for x in 0..MAX; index[x] = -1; end
    (n - 1).downto(0) do |i|
        x = a[i] - MIN;  nxt[i] = index[x];  index[x] = i
    end
    j = 0
    for x in 0..(MAX - MIN)
        i = index[x]
        while (i >= 0) 
            b[j] = a[i];  j += 1;  i = nxt[i]
        end
    end
end

N = 100000

a = []; b = []; work = []

for i in 0...N
    a[i] = ((MAX - MIN + 1) * rand() + MIN).to_i
end
mapsort(N, a, b, work)

exit 0

